###########################################################################
#
#   Copyright (c) 2000 Morten W. Petersen <morten@esol.no>
#	Copyright (c) 2000 Thingamy Ltd.
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, 
#    MA 02111-1307 USA
#
#
###########################################################################

# $Author: morten $
# $Revision: 1.2 $


__doc__ = 'Documentation string.'
__version__ = '0.1.0'

from Globals import HTMLFile
from Globals import Persistent
from Globals import default__class_init__
import Acquisition
import AccessControl.Role
import OFS.Folder
import news
import base_item
import smtplib


manage_add_news_letter_form = HTMLFile('news_letter_add', globals())

def manage_add_news_letter(self, news_items, title, prelude, postlude, REQUEST=None):
	"Add an instance of the Category class"

	try: REQUEST['news_items']
	except AttributeError: raise 'Error', 'No news items selected'

	new_id = self.get_unique_id()

	connection = smtplib.SMTP(self.newsletter_mailhost or 'localhost')

	newsletter = self.make_newsletter(items=news_items, title=title, prelude=prelude,
					postlude=postlude)

	connection.sendmail(self.newsletter_originator, [self.amplifier], newsletter)

	self._setObject(new_id, news_letter(new_id, title, newsletter))

	if REQUEST is not None:

		REQUEST.RESPONSE.redirect(self.absolute_url())


class news_letter(
	OFS.Folder.Folder,
	Persistent,
	Acquisition.Implicit,
	AccessControl.Role.RoleManager,
	base_item.base_item
	):
	"Documentation string"

	meta_type = 'Newsletter'
	icon = 'misc_/NewsFolder/dtmldoc.gif'

	_properties = (
		{'id':'title', 'type':'string'},
		{'id':'body', 'type':'text'},
		)

	__ac_permissions__ = (
		('View management screens',
		 ('manage_tabs', 'manage_main')),
		('Change Permissions',
		 ('manage_access',)),
		('View newsletters',
		 ('',)),
		)

	index_html = HTMLFile('news_letter_index', globals())


	def __init__(self, id, title='', body=''):
		"Initialize the class instance"

		self.id = id
		self.title = title
		self.body = body


default__class_init__(news_letter)

