###########################################################################
#
#   Copyright (c) 2000 Morten W. Petersen <morten@esol.no>
#	Copyright (c) 2000 Thingamy Ltd.
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, 
#    MA 02111-1307 USA
#
#
###########################################################################

# $Author: morten $
# $Revision: 1.3 $


__doc__ = 'Documentation string.'
__version__ = '0.1.0'

from Globals import HTMLFile
from Globals import Persistent
from Globals import default__class_init__
import Acquisition
import AccessControl.Role
import OFS.Folder
import Products
import base_item
import string
import news_letter

def manage_add_news_letter_folder(self, id, title, REQUEST=None, RESPONSE=None):
	"Add an instance of the NewsFolder class"

	self._setObject(id, news_letter_folder(id, title))

	if RESPONSE is not None:

		RESPONSE.redirect(REQUEST['URL3'])


class news_letter_folder(
	Products.ZCatalog.CatalogAwareness.CatalogAware,
	OFS.Folder.Folder,
	Persistent,
	Acquisition.Implicit,
	AccessControl.Role.RoleManager,
	base_item.base_item
	):
	"Documentation string"

	meta_type = 'NewsLetterFolder'
	icon = 'misc_/NewsFolder/Folder_icon.gif'
	#default_catalog = 'Catalog'

	_properties = (
		{'id':'title', 'type':'string'},
		)

	meta_types = (
		{'name':'NewsLetter', 'action':'manage_add_news_letter_form'},
		)

	manage_add_news_letter_form = news_letter.manage_add_news_letter_form
	manage_add_news_letter = news_letter.manage_add_news_letter


	__ac_permissions__ = (
		('View management screens',
		 ('manage_tabs', 'manage_main')),
		('Change Permissions',
		 ('manage_access',)),
		('Add Newsletter',
		 ('manage_add_news_letter', 'manage_add_news_letter_form')),
		('View NewsLetters',
		 ('',)),
		)

	index_html = HTMLFile('news_letter_folder_index', globals())
	display = HTMLFile('news_folder_display', globals())

	base_edit = HTMLFile('news_folder_edit', globals())

	def __init__(self, id, title):

		self.id = id
		self.title = title

		try:

			self.index_object()

		except AttributeError:

			# ZCatalog isn't available

			pass


	def make_newsletter(self, items=[], title='', prelude='', postlude=''):
		"""Makes a newsletter (...) """

		print items, title, prelude, postlude

		news_items_body = ''

		for news_item in items:

			category, news_item = string.split(news_item, ':')

			news_item = self.getParentNode()[category][news_item]

			news_items_body = news_items_body + """%s

%s

<url:%s>
----
""" % (news_item.title, news_item.short_body, news_item.absolute_url())

			news_item.published_via_email = 1

		newsletter = """Subject: Newsletter from %s - %s

%s

%s

%s
""" % ('FIXME', # FIXME
	 title, prelude, news_items_body, postlude)

		return newsletter


default__class_init__(news_letter_folder)
